------------------------------------------------------------------------------
--                                                                          --
--                            Matreshka Project                             --
--                                                                          --
--                          Ada Modeling Framework                          --
--                                                                          --
--                        Runtime Library Component                         --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2011-2012, Vadim Godunko <vgodunko@gmail.com>                --
-- All rights reserved.                                                     --
--                                                                          --
-- Redistribution and use in source and binary forms, with or without       --
-- modification, are permitted provided that the following conditions       --
-- are met:                                                                 --
--                                                                          --
--  * Redistributions of source code must retain the above copyright        --
--    notice, this list of conditions and the following disclaimer.         --
--                                                                          --
--  * Redistributions in binary form must reproduce the above copyright     --
--    notice, this list of conditions and the following disclaimer in the   --
--    documentation and/or other materials provided with the distribution.  --
--                                                                          --
--  * Neither the name of the Vadim Godunko, IE nor the names of its        --
--    contributors may be used to endorse or promote products derived from  --
--    this software without specific prior written permission.              --
--                                                                          --
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS      --
-- "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT        --
-- LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR    --
-- A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT     --
-- HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   --
-- SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED --
-- TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR   --
-- PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF   --
-- LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING     --
-- NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS       --
-- SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.             --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 2714 $ $Date: 2012-03-24 10:29:08 +0400 (Sat, 24 Mar 2012) $
------------------------------------------------------------------------------
--  This file is generated, don't edit it.
------------------------------------------------------------------------------
--  A qualifier value is not an action. It is an element that identifies 
--  links. It gives a single qualifier within a link end data specification.
------------------------------------------------------------------------------
with AMF.UML.Elements;
limited with AMF.UML.Input_Pins;
limited with AMF.UML.Properties;

package AMF.UML.Qualifier_Values is

   pragma Preelaborate;

   type UML_Qualifier_Value is limited interface
     and AMF.UML.Elements.UML_Element;

   type UML_Qualifier_Value_Access is
     access all UML_Qualifier_Value'Class;
   for UML_Qualifier_Value_Access'Storage_Size use 0;

   not overriding function Get_Qualifier
    (Self : not null access constant UML_Qualifier_Value)
       return AMF.UML.Properties.UML_Property_Access is abstract;
   --  Getter of QualifierValue::qualifier.
   --
   --  Attribute representing the qualifier for which the value is to be 
   --  specified.

   not overriding procedure Set_Qualifier
    (Self : not null access UML_Qualifier_Value;
     To   : AMF.UML.Properties.UML_Property_Access) is abstract;
   --  Setter of QualifierValue::qualifier.
   --
   --  Attribute representing the qualifier for which the value is to be 
   --  specified.

   not overriding function Get_Value
    (Self : not null access constant UML_Qualifier_Value)
       return AMF.UML.Input_Pins.UML_Input_Pin_Access is abstract;
   --  Getter of QualifierValue::value.
   --
   --  Input pin from which the specified value for the qualifier is taken.

   not overriding procedure Set_Value
    (Self : not null access UML_Qualifier_Value;
     To   : AMF.UML.Input_Pins.UML_Input_Pin_Access) is abstract;
   --  Setter of QualifierValue::value.
   --
   --  Input pin from which the specified value for the qualifier is taken.

end AMF.UML.Qualifier_Values;
